# Annotation Elements

## Text

To create a Text view:

1. Select **Text** in **Toolbox (Annotation)**.
2. Drag on the diagram as the size of Text.

You can also create a Text view by just double clicking mouse left button on blank area of diagram.

You can enter multiline text by double clicking the Text view element. If you want to add a newline character, press `Shift-Enter`.

You can align texts inside the TextBox (Text, Note) with **Text Alignment** buttons in **Style Editor**.

![Text alignments for textual annotations](https://content.gitbook.com/content/aNbtXAm2MUsbrMlAEZb1/blobs/JyxrWsxpThI4CtRIWVtc/textalign.png)

## Text Box

Text Box is a box has text inside. The difference from Text view, it has border line color and fill color.

To create a Text Box view:

1. Select **Text Box** in **Toolbox (Annotation)**.
2. Drag on the diagram as the size of Text Box.

You can enter multiline text by double clicking the Text Box view element. If you want to add a newline character, press `Shift-Enter`.

## Note and Note Link

To create a Note with Link on a element:

1. Select **Note** in **Toolbox (Annotation)**.
2. Drag on the diagram as the size of Note.
3. Select **Note Link** in **Toolbox (Annotation)**.
4. Drag on an element and drop on the Note.

You can enter multiline text by double clicking the Note view element. If you want to add a newline character, press `Shift-Enter`.

## Free Line

Free Line is a multi-point line supporting various line formatting including line style, line pattern, and line-end shapes. You can set these line format in **Style Editor**.

![Styles for Free Line element](https://content.gitbook.com/content/aNbtXAm2MUsbrMlAEZb1/blobs/1qnSpYvgiGOMl0iCFvrv/freelines.png)

To create a Free Line view:

1. Select Free**Free Line** in **Toolbox (Annotation)**.
2. Drag from an end-point and drop on another end-point.

## Hyperlink

To create a Hyperlink view:

1. Select **Hyperlink** in **Toolbox (Annotation)**.
2. Drag on the diagram as the size of Hyperlink.

You can enter a link for a model element or a URL. To link a model element, click `reference` property in **Property Editor** and select a model element to link in **Element Picker Dialog**. Or to link a URL, enter full URL in `url` property (e.g. `https://staruml.io`).

To open the URL in `url` or the diagram in `reference` property, double-clicking the Hyperlink.  `http://` or `https://` should be included to open in external web browser by double-clicking the Hyperlink. Link to a local file is not supported. If an element (not a diagram) is in `reference` property, it will be selected in **Model Explorer**.

If you want to show Hyperlink name in the diagram instead of URL or element name, check `showName` property in the **Property Editor**.

## Shapes (Rectangle, Rounded Rectangle, Ellipse)

To create a shape view:

1. Select a shape (**Rectangle, Round Rectangle, Ellipse**) in **Toolbox (Annotation)**.
2. Drag on the diagram as the size of shape.

## Image

You can embed an image file (PNG, JPEG, SVG). We recommend to embed an image smaller than 640x640.

To add an image:

1. Select **Image** in **Toolbox (Annotation)**.
2. Click on the diagram at the point you want to place an image.
3. Select an image file (.png, .jpeg/jpg, .svg) in Open Dialog.

Or, you can add an image by drag an image file and then drop on the diagram area.

You can change the image file by double-clicking on the Image view.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.staruml.io/user-guide/annotation-elements.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
